var CPTOver = {

  ptPrefs: Services.prefs.getBranch("extensions.copyplaintext."),

  copyplaintext: function(){
    try{
      let string = CPTOver.copyplaintext_getSelection() + "";
      if(CPTOver.ptPrefs.getBoolPref("trim"))
        string = string.replace(/^\s*|\s*$/g, "");
      if(CPTOver.ptPrefs.getBoolPref("reduceLine"))
        string = string.replace(/[\n\r]+/g, "\n");
      if(CPTOver.ptPrefs.getBoolPref("reduceSpace"))
        string = string.replace(/[ \t]+/g, " ");
      if (CPTOver.ptPrefs.getBoolPref("reformatSpecial")) {
        string = string.replace(/[„|“|”]+/g, "\"")
          .replace(/[‘|’]+/g, "'")
          .replace(/[—|–]+/g, "-")
          .replace(/[ñ]+/g, "n")
          .replace(/[®]+/g, "\(r\)")
          .replace(/[©]+/g, "\(c\)")
          .replace(/[•]+/g, "*")
          .replace(/[™]+/g, "TM")
          .replace(/[…]+/g, "...");
      }
      if(string != null && string.length > 0){
        let oClipBoard = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
                         .getService(Components.interfaces.nsIClipboardHelper);
        oClipBoard.copyString(string);
      }
    }
    catch(err) { 
      let strings = document.getElementById("copyplainStrings");
      Services.prompt.alert(null,"Copy Plain Text",strings.getString("unknownErrorOccur") + "\n" + err);
    }
  },

  copy_withoutspaces: function(){
    try{
      let string = CPTOver.copyplaintext_getSelection() + "";
      string = string.replace(/[ \s]+/g, "");
      if(string != null && string.length > 0){
        let oClipBoard = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
                         .getService(Components.interfaces.nsIClipboardHelper);
        oClipBoard.copyString(string);
      }
    }
    catch(err) { 
      let strings = document.getElementById("copyplainStrings");
      Services.prompt.alert(null,"Copy Plain Text",strings.getString("unknownErrorOccur") + "\n" + err);
    }
  },

  copyplaintext_init: function(){
    let ptContext = document.getElementById('contentAreaContextMenu');
    if(ptContext){ptContext.setAttribute("popupshowing", CPTOver.copyplaintext_showContextMenu());}
    ptContext = document.getElementById('msgComposeContext') || document.getElementById('mailContext');

    if(ptContext){ptContext.setAttribute("popupshowing", CPTOver.copyplaintext_showContextMenu());}
    let ptEdit = document.getElementById('menu_EditPopup');

    if(ptEdit){ptEdit.setAttribute("popupshowing", CPTOver.copyplaintext_showEditMenu());}
    CPTOver.copyplaintext_init2()
  },

  copyplaintext_init2: function(){
    document.getElementById("copyplaintext-context-menu").hidden=(CPTOver.copyplaintext_showMenu()==false);
    document.getElementById("copyplaintext-edit-menu").hidden=(CPTOver.copyplaintext_showEditMenu()==false);
    if(CPTOver.ptPrefs.getBoolPref("default")==true){
      document.getElementById("key_copyPlainText").setAttribute("disabled", true);
      // Remove copy plain text menu items
      document.getElementById("copyplaintext-context-menu").setAttribute("collapsed", true);
      document.getElementById("copyplaintext-edit-menu").setAttribute("collapsed",true);
      // Hijack menus
      document.getElementById("cmd_copy").addEventListener("command", function() {CPTOver.copyplaintext();});
      document.getElementById("key_copy").setAttribute("oncommand", "CPTOver.copyplaintext()");
      //document.getElementById("key_copy").addEventListener("command", function() {CPTOver.copyplaintext();});
    }
    else{
      document.getElementById("key_copyPlainText").setAttribute("disabled", false);
      // Display copy plain text menu items
      document.getElementById("copyplaintext-context-menu").setAttribute("collapsed",false);
      document.getElementById("copyplaintext-edit-menu").setAttribute("collapsed",false);
      // Hijack menus
      document.getElementById("cmd_copy").addEventListener("command", function() {goDoCommand('cmd_copy');});
      document.getElementById("key_copy").addEventListener("command", function() {goDoCommand('cmd_copy');});
    }
    if(CPTOver.ptPrefs.getBoolPref("trim")==false&&CPTOver.ptPrefs.getBoolPref("reduceLine") == false&&CPTOver.ptPrefs.getBoolPref("reduceSpace")==false)
    {
      document.getElementById("key_copyPlainText").setAttribute("disabled", true);
      document.getElementById("copyplaintext-context-menu").setAttribute("disabled", true);
      document.getElementById("copyplaintext-edit-menu").setAttribute("disabled", true);
    } else {
      document.getElementById("copyplaintext-context-menu").setAttribute("disabled", false);
    }
    let cptreduceall = CPTOver.ptPrefs.getBoolPref("displayReduceAllSpaces") == false;
    if(cptreduceall) {
      document.getElementById("copyplaintext-context-nospaces").hidden = true;
    } else {
        document.getElementById("copyplaintext-context-nospaces").hidden = false;
    }

    //Compare addon version
    Components.utils.import("resource://gre/modules/AddonManager.jsm");
    AddonManager.getAddonByID("copyplaintext@teo.pl", function(addon) {
      let prevVersion = CPTOver.ptPrefs.getCharPref('lastVersion');
      if (Services.vc.compare(prevVersion, addon.version) < 0) {
        if((navigator.userAgent.search(/Firefox/gi)>0) || (navigator.userAgent.search(/SeaMonkey/gi) >= 0)) {
          let url = "chrome://copyplaintext/content/update.xhtml";
          gBrowser.selectedTab = gBrowser.addTab(url);
          CPTOver.ptPrefs.setCharPref('lastVersion', addon.version);
        }
        if(navigator.userAgent.search(/Thunderbird/gi) >= 0) {Services.wm
                    .getMostRecentWindow("mail:3pane").document.getElementById("tabmail")
                    .openTab("contentTab", {contentPage: "chrome://copyplaintext/content/update.xhtml"});
          CPTOver.ptPrefs.setCharPref('lastVersion', addon.version);
        }
      }
    });
  },

  copyplaintext_showMenu: function(){
    try {
      let string = CPTOver.copyplaintext_getSelection();
      if(string != null && string.length > 0) {
        return true;
      }
    }catch(err) {}
    return false;
  },

  copyplaintext_getSelection: function() {
    let focusedWindow = document.commandDispatcher.focusedWindow;
    let searchStr = focusedWindow.getSelection.call(focusedWindow);
    searchStr = searchStr.toString();
    return searchStr;
  },

  copyplaintext_showEditMenu: function(){
    if(document.getElementById('copyplaintext-edit-menu') != null)
      document.getElementById('copyplaintext-edit-menu').setAttribute("disabled", !CPTOver.copyplaintext_showMenu());
  },

  copyplaintext_showContextMenu: function(){
    if(document.getElementById('copyplaintext-context-menu') != null){
      document.getElementById('copyplaintext-context-menu').setAttribute("collapsed", !CPTOver.copyplaintext_showMenu());
    }
  },

  showOptions: function() {
    let features = 'chrome,titlebar,toolbar,centerscreen,resizable,';
    window.openDialog('chrome://copyplaintext/content/options.xul', 'Copy Plain Text options', features);
  }
};

Components.utils.import("resource://gre/modules/Services.jsm");
window.addEventListener("load", CPTOver.copyplaintext_init, true);
window.addEventListener("popupshowing", CPTOver.copyplaintext_init2, true);